import { world, Vector3 } from "@minecraft/server"

const dir: { [key: string]: "x" | "y" | "z" } = { "North": "z", "South": "z", "East": "x", "West": "x", "Up": "y", "Down": "y" }
const dirNum: { [key: string]: number } = { "North": -1, "South": 1, "East": 1, "West": -1, "Up": 1, "Down": -1 }

export const apiNumbers = new class apiNumbers {
    clamp(value: number, min: number, max: number): number { return Math.max(min, Math.min(value, max)) }

    distance(pos1: Vector3, pos2: Vector3): number { return Math.sqrt(((pos1.x - pos2.x) ** 2) + ((pos1.y - pos2.y) ** 2) + ((pos1.z - pos2.z) ** 2)) }

    centerVector(pos: Vector3): Vector3 { return {x: pos.x +0.5, y: pos.y +0.5, z: pos.z +0.5} }

    vectorToString(pos: Vector3): string { return `${pos.x}, ${pos.y}, ${pos.z}` }

    vectorAdd(pos: Vector3, direction: directions): Vector3 {
        const newVec = {...pos}
        newVec[dir[direction]] += dirNum[direction]
        return newVec
    }
}

export type directions = "North" | "South" | "East" | "West" | "Up" | "Down"