import { world, ItemStack, Player } from "@minecraft/server"
import { wandSize } from "../variables"

export const apiConfigInfo = new class apiConfigInfo {
    getWandConfig(player: Player, item: ItemStack): wandConfigInfo | undefined {
        const dynamic = player.getDynamicProperty(`builder_wand:config_${item.typeId.replace("builder_wand:", "").replace("builder_", "")}`)
        if(dynamic) return JSON.parse(dynamic as string) as wandConfigInfo
        return this.setWandConfig(player, item, defaultWandInfo(wandSize[item.typeId]))
    }

    setWandConfig(player: Player, item: ItemStack, config: wandConfigInfo): wandConfigInfo {
        player.setDynamicProperty(`builder_wand:config_${item.typeId.replace("builder_wand:", "").replace("builder_", "")}`, JSON.stringify(config))
        return config
    }
}

function defaultWandInfo(max = 3){
    return {
        size: max,
        connect: false
    }
}

interface wandConfigInfo {
    size: number,
    connect: boolean
}