import { world, Player } from "@minecraft/server"

export const apiCooldown = new class apiCooldown {
    getTime(): number {
        return (new Date().getTime()) /1000
    }

    getTimeOut(player: Player): number {
        const cooldownEnd = player.getDynamicProperty("builder_wand:cooldown_preview_area")
        if(cooldownEnd == undefined) return this.setCooldown(player, true)
        return cooldownEnd as number
    }

    setCooldown(player: Player, exists = false): number {
        const timeOut = this.getTime() + (!exists ? 2 : 0)
        player.setDynamicProperty("builder_wand:cooldown_preview_area", timeOut)
        return timeOut
    }

    testTimeOut(player: Player): boolean { return this.getTime() < this.getTimeOut(player) }
}